function Create(self)
  self.ShootTimer = Timer()
  self.SharpRange = self.SharpLength
  self.Clicked = false
  self.Recoil = 0
  self.RecoilRot = 0
end

function Update(self)
  local negatore = 1
	if self.HFlipped then
		negatore = -1;
	end
	local RecoilReduction = 0.1
	local user = nil
	for parent in MovableMan.Actors do
		if parent.ID == self.RootID then
			user = ToAHuman(parent)
			break
		end
	end
	if user ~= nil then
    --Taking the user into account
    local ArmCount = 0
    local ArmLength = 0
    if user.FGArm ~= nil then
      RecoilReduction = RecoilReduction + user.FGArm.Mass
      ArmCount = ArmCount + 1
      ArmLength = user.FGArm.Diameter
    end
    if user.BGArm ~= nil then
      RecoilReduction = RecoilReduction + user.BGArm.Mass
      ArmCount = ArmCount + 1
      ArmLength = math.max(user.BGArm.Diameter , ArmLength)
    end
    ArmLength = ArmLength + user.Diameter

    if user.FGLeg ~= nil then
      RecoilReduction = RecoilReduction + user.FGLeg.Mass
      ArmCount = ArmCount + 1
    end
    if user.BGLeg ~= nil then
      RecoilReduction = RecoilReduction + user.BGLeg.Mass
      ArmCount = ArmCount + 1
    end
    
    --Regaining control
    
    RecoilReduction = (RecoilReduction * user.Mass)^0.5
    self.RecoilRot = self.RecoilRot * 0.995^(RecoilReduction^0.5)
    RecoilReduction = RecoilReduction * (ArmCount * 0.25)^0.5
    if self.RecoilRot > 8 or self.RecoilRot < -8 then
      user:GetController():SetState(Controller.BODY_CROUCH,true)
    end
    if self.RecoilRot > 12 or self.RecoilRot < -12 then
      user:GetController():SetState(Controller.WEAPON_DROP,true)
    end
  else
    self.Recoil = 0
    self.RecoilRot = 0
  end
  if self.Magazine ~= nil then
    self.Magazine.Frame = 11 - math.floor((self.Magazine.RoundCount/self.Magazine.Capacity) * 11)
    if self:IsActivated() then
      if self.Magazine.RoundCount > 0 and self.ShootTimer:IsPastSimMS(60000/self.RateOfFire) and (self.Clicked or self.FullAuto) then
        self.ShootTimer:Reset()
        self.Recoil = self.Recoil + 12
        if self.Recoil > 360 then
          self.Recoil = self.Recoil - 360
        end   
      end
    else
      self.Clicked = true
      self.Recoil = self.Recoil - math.sin(self.Recoil/90*math.pi)*5
    end
    self.RecoilRot = self.RecoilRot + math.sin(self.Recoil/180*math.pi) / (RecoilReduction/20)^0.5
  else
    self.ShootTimer:Reset()
  end
	if user ~= nil then
    self.SharpLength = math.max(0 , self.SharpRange - (math.abs(self.RecoilRot)*self.SharpRange) * 0.02)
    self.RotAngle = self.RotAngle - self.RecoilRot * negatore * 0.04
  end
end