function Create(self)
  self.StickedDevice = nil
  self.ShootTimer = Timer()
  self.SharpRange = self.SharpLength
  self.Clicked = false
  self.Recoil = 0
  self.MovementPunisherment = 0.5 --How much you are punished for moving while firing
end

function Update(self)
  local negatore = 1
	if self.HFlipped then
		negatore = -1;
	end
	self.Recoil = self.Recoil * 0.99
	local RecoilReduction = 0.1
	local user = nil
	for parent in MovableMan.Actors do
		if parent.ID == self.RootID then
			user = ToAHuman(parent)
			break
		end
	end
	if user ~= nil then
    --Taking the user into account
    local ArmCount = 0
    local ArmLength = 0
    if user.FGArm ~= nil then
      RecoilReduction = RecoilReduction + user.FGArm.Mass
      ArmCount = ArmCount + 1
      ArmLength = user.FGArm.Diameter
    end
    if user.BGArm ~= nil then
      RecoilReduction = RecoilReduction + user.BGArm.Mass*0.25
      ArmCount = ArmCount + 1
      ArmLength = math.max(user.BGArm.Diameter , ArmLength)
    end
    ArmLength = ArmLength + user.Diameter
    
    --Regaining control
    local MovementMulti = ((ArmLength/self.MovementPunisherment - math.min(user.Vel.Magnitude , ArmLength/self.MovementPunisherment))/ArmLength*self.MovementPunisherment)
    if self.Recoil > 0.035 * MovementMulti^2*(25+user.Health)/200 then
      self.Recoil = self.Recoil - 0.035 * MovementMulti^2*(25+user.Health)/200
    else
      self.Recoil =  0
    end
    
    RecoilReduction = (RecoilReduction * user.Mass)^0.5
    if self.Diameter > user.Diameter then --if the user is shorter than the gun, make it extra important to have an extra arm for support
      RecoilReduction = RecoilReduction * ArmCount / 1.25
    end
    if self.Recoil > 4 then
      user:GetController():SetState(Controller.BODY_CROUCH,true)
    end
    if self.Recoil > 7 then
      user:GetController():SetState(Controller.WEAPON_DROP,true)
    end
  else
    self.Recoil = 0
  end
  if self.Magazine ~= nil then
    if self:IsActivated() then
      if self.Magazine.RoundCount > 0 and self.ShootTimer:IsPastSimMS(60000/self.RateOfFire) and (self.Clicked or self.FullAuto) then
        self.ShootTimer:Reset()
        self.Recoil = self.Recoil + (60 / RecoilReduction)^2
        if MovableMan:ValidMO(self.StickedDevice) and self.StickedDevice ~= nil and self.Sharpness == 3 then
          self.Recoil = self.Recoil + (math.min(1, self.StickedDevice.Mass) * 60 / RecoilReduction)^3
        end
      end
    else
      self.Clicked = true
    end
  else
    self.ShootTimer:Reset()
  end
  if self.Sharpness == 4 then
    self.StickedDevice = nil
    self.Sharpness = 1
  end
  if self.Sharpness == 2 then
    self.StickedDevice = nil
    local minDistance = 35
    local truegun = nil
    for i = 1,MovableMan:GetMOIDCount()-1 do
      self.gun = MovableMan:GetMOFromID(i);
      if self.gun.ClassName == "TDExplosive" and SceneMan:ShortestDistance(self.gun.Pos,self.Pos,SceneMan.SceneWrapsX).Magnitude < minDistance then
        minDistance = SceneMan:ShortestDistance(self.gun.Pos,self.Pos,SceneMan.SceneWrapsX).Magnitude
        truegun = self.gun
      end
    end
    if truegun ~= nil then
      self.StickedDevice = truegun
      self.Sharpness = 3
    end
  end
  if MovableMan:ValidMO(self.StickedDevice) and self.StickedDevice ~= nil and self.Sharpness == 3 then
    self.StickedDevice.Pos = self.Pos + self:RotateOffset(Vector(5 , -3))
    self.StickedDevice.Vel = self.Vel
    self.StickedDevice.RotAngle = self.RotAngle
    self.StickedDevice.HFlipped = self.HFlipped
  else
    self.Sharpness = 1
    self.StickedDevice = nil
  end
	if user ~= nil then
    self.SharpLength = math.max(0 , self.SharpRange - (self.Recoil*self.SharpRange) * 0.2 + (math.random(-self.Recoil*(100 - user.Health)^3, self.Recoil*(100 - user.Health)^3)*0.0000005)^2*self.SharpRange)
    self.RotAngle = self.RotAngle + self.Recoil * negatore * 0.02 + (math.random(-self.Recoil*(100 - user.Health)^4, self.Recoil*(100 - user.Health)^4)*0.000000005)^2
  end
end