function Create(self)

	self.fireTimer = Timer();
	self.blinkTimer = Timer();
	self.effectTimer = Timer();
	self.DoubleClickTimer = Timer();
	self.Clicked = true
	self.Charging = false
	self.fireOn = false;

	self.particleTable = {};
	self.chargeCounter = 0;
  self.effectCounter = 0

	self.maxCharge = 400;
	self.OriginalMass = self.Mass
	
	self.DamageCounter = 0
	self.DamageRatio = 1 -- if valina diggers damage is nerfed set this to 4. It makes it a very powerful close combat weapon without being WTF BBQ

  self.Dechargin = false
  
  self.AgeCheck = 0
end

function Update(self)
  if self.AgeCheck + 100 < self.Age then
    self.Dechargin = false
    self.chargeCounter = 0;
  end
  self.AgeCheck = self.Age
  self.Mass = self.OriginalMass + self.chargeCounter / 20
  if self.HFlipped == false then
    self.reverseNum = 1;
  else
    self.reverseNum = -1;
  end
	if self:IsActivated() and self.Dechargin == false then
    if self.Clicked then
      if self.DoubleClickTimer:IsPastSimMS(250) then
        self.DoubleClickTimer:Reset();
      else
        self.Charging = true
      end
    end
    if self.Charging == true then
      if self.chargeCounter > self.maxCharge/4 then
        local actor = MovableMan:GetMOFromID(self.RootID);
        if MovableMan:IsActor(actor) and ToActor(actor):IsPlayerControlled() == false then
          ToActor(actor):GetController():SetState(Controller.WEAPON_FIRE,false);
        end
      end

      if self.blinkTimer:IsPastSimMS(math.floor(2000/(200 + self.chargeCounter))) and self.chargeCounter < self.maxCharge and self.particleTable ~= nil then
        self.blinkTimer:Reset();
        self.chargeCounter = self.chargeCounter + 1;
        self.effectCounter = self.effectCounter + 1
        if self.effectCounter > 5 then
          local effectPar = nil
          if math.random(self.chargeCounter*0.75, self.chargeCounter) > 300 then
            effectPar = CreateMOPixel("Blue Annihi-Digger Effect Particle");
          else
            effectPar = CreateMOPixel("Annihi-Digger Effect Particle");
          end
          effectPar.Pos = self.MuzzlePos;
          effectPar.PinStrength = 1000;
          MovableMan:AddParticle(effectPar);
          self.particleTable[#self.particleTable+1] = effectPar;
          self.effectCounter = 0
        end
      end

      for i = 1, #self.particleTable do
        if MovableMan:IsParticle(self.particleTable[i]) then
          self.particleTable[i].ToDelete = false;
          self.particleTable[i].ToSettle = false;
          self.particleTable[i].PinStrength = 1000;
          self.particleTable[i].Pos = self.MuzzlePos;
        end
      end

      if self.effectTimer:IsPastSimMS(550-((self.chargeCounter/self.maxCharge)*500)) then
        self.effectTimer:Reset();
        local effectPar = CreateMOPixel("Laser Cannon Effect Particle 2");
        effectPar.Pos = self.MuzzlePos;
        effectPar.Vel = Vector(40,0):RadRotate(math.random()*(math.pi*2));
        effectPar:SetWhichMOToNotHit(MovableMan:GetMOFromID(self.RootID),-1);
        MovableMan:AddParticle(effectPar);
      end
    else
      local effectPar = CreateMOSRotating("Light Flash Annihi-Digger Medium Digger");
      effectPar.Pos = self.MuzzlePos + self:RotateOffset(Vector(4 , 0))
      effectPar.Vel = self.Vel
      effectPar.RotAngle = self.RotAngle
      if self.HFlipped then
        effectPar.RotAngle = effectPar.RotAngle + math.pi
      end
      
      effectPar.Frame = math.floor(math.random(0 , 3.999999))
      MovableMan:AddParticle(effectPar);
      effectPar.HFlipped = self.HFlipped
      local effectPar = CreateMOPixel("Light Glow Annihi-Digger Medium Digger");
      effectPar.Pos = self.MuzzlePos + self:RotateOffset(Vector(10 , 0));
      effectPar.PinStrength = 1000;
      MovableMan:AddParticle(effectPar);
      for i = 1, 3 do
        local damagePar = CreateMOPixel("Particle Annihi-Digger Medium Digger");
        damagePar.Pos = self.MuzzlePos
        damagePar.Vel = Vector((75+math.random(0,30)) * self.reverseNum,0):RadRotate(self.RotAngle + math.random(-50, 50)*0.01);
        damagePar:SetWhichMOToNotHit(MovableMan:GetMOFromID(self.RootID),-1);
        if self.DamageCounter < 0 then
          self.DamageCounter = self.DamageRatio
        else
          HitsMOs = false
        end
        self.DamageCounter = self.DamageCounter - 1
        MovableMan:AddParticle(damagePar);
      end
    end
    if self.Charging == false then
      self.Clicked = false
    end
	else
    self.Dechargin = true

		for i = 1, #self.particleTable do
			if MovableMan:IsParticle(self.particleTable[i]) then
				self.particleTable[i].ToDelete = true;
			end
		end
		self.fireTimer:Reset();
		self.particleTable = {};
		self.Clicked = true
		self.Charging = false
	end
	if self.Dechargin then
    self.chargeCounter = math.floor(self.chargeCounter)
		if self.chargeCounter > 0 then
      local randomEffect = math.random(self.chargeCounter*0.5, self.chargeCounter)
      local effectPar = nil
      if randomEffect > 50 then
        effectPar = CreateMOSRotating("Flash Annihi-Digger Medium Digger");
        effectPar.Scale = 0.75 + self.chargeCounter*0.002
      else
        effectPar = CreateMOSRotating("Light Flash Annihi-Digger Medium Digger");
      end
      effectPar.Pos = self.MuzzlePos
      effectPar.Vel = self.Vel
      effectPar.RotAngle = self.RotAngle
      if self.HFlipped then
        effectPar.RotAngle = effectPar.RotAngle + math.pi
      end
      effectPar.Frame = math.floor(math.random(0 , 1.999999))
      MovableMan:AddParticle(effectPar);
      effectPar.HFlipped = self.HFlipped
      if randomEffect > 150 then
        effectPar = CreateMOPixel("Blue Glow Annihi-Digger Medium Digger");
      elseif randomEffect > 100 then
        effectPar = CreateMOPixel("Light Blue Glow Annihi-Digger Medium Digger");
      elseif randomEffect > 50 then
        effectPar = CreateMOPixel("Glow Annihi-Digger Medium Digger");
      else
        effectPar = CreateMOPixel("Light Glow Annihi-Digger Medium Digger");
      end
      effectPar.Pos = self.MuzzlePos + self:RotateOffset(Vector(10 , 0));
      effectPar.PinStrength = 1000;
      MovableMan:AddParticle(effectPar);
			for i = math.max(1 , self.chargeCounter - 5 - (self.chargeCounter*0.01)), self.chargeCounter do
				local damagePar = nil
				if randomEffect > 150 then
          damagePar = CreateMOPixel("Particle Annihi-Digger Heavy Digger");
        else
          damagePar = CreateMOPixel("Particle Annihi-Digger Medium Digger");
        end
				damagePar.Pos = self.MuzzlePos + Vector((math.random(-100 , 100)*i/2500), 0):RadRotate(self.RotAngle+math.pi/2);
				damagePar.Vel = Vector((75+math.random(0,30)+i/2) * self.reverseNum,0):RadRotate(self.RotAngle + math.random(-150, 150)/(i + 120));
				damagePar.Sharpness = 15 + i/4
				damagePar.LifeTime = 1500/(100 + i)
				damagePar:SetWhichMOToNotHit(MovableMan:GetMOFromID(self.RootID),-1);
        if self.DamageCounter < 0 then
          self.DamageCounter = self.DamageRatio
        else
          HitsMOs = false
        end
        self.DamageCounter = self.DamageCounter - 1
				MovableMan:AddParticle(damagePar);
			end

			for i = 1, #self.particleTable do
				if MovableMan:IsParticle(self.particleTable[i]) then
					self.particleTable[i].ToDelete = true;
				end
			end

			self.particleTable = {};

			local soundfx = CreateAEmitter("Dummy Laser Cannon Sound Fire");
			soundfx.Pos = self.MuzzlePos;
			MovableMan:AddParticle(soundfx);

			self.chargeCounter = math.max(0 , self.chargeCounter - 5 - (self.chargeCounter*0.01));
		else
      self.Dechargin = false
		end
	end
	if self.Magazine ~= nil then
    if self.chargeCounter > 0 then
      self.Magazine.RoundCount = math.max(1 , self.chargeCounter / 4)
    else
      self.Magazine.RoundCount = -1
    end
	end
end

function Destroy(self)

	for i = 1, #self.particleTable do
		if MovableMan:IsParticle(self.particleTable[i]) then
			self.particleTable[i].ToDelete = true;
		end
	end

end